package handler

import (
	"net/http"
	"strconv"

	"gitea.michaelthomson.dev/mthomson/habits/internal/todo/service"
)

func HandleTodoDelete(todoService TodoDeleter) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		idString := r.PathValue("id")

		id, err := strconv.ParseInt(idString, 10, 64)

		if err != nil {
			http.Error(w, "", http.StatusBadRequest)
			return
		}

		err = todoService.DeleteTodo(id)

		if err != nil {
			if err == service.ErrNotFound {
				http.Error(w, "", http.StatusNotFound)
				return
			}

			http.Error(w, "", http.StatusInternalServerError)
			return
		}

		w.WriteHeader(http.StatusNoContent)
	}
}
